//
//  MainRoutine.h
//  MINtS analyzer
//
//  Created by 萩原 弘一 on 2013/09/06.
//  Copyright (c) 2013年 萩原 弘一. All rights reserved.
//
/* Copyright 2016 Koichi Hagiwara
 This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#import <Foundation/Foundation.h>
#import "MINtS analyzer.h"

@class MintsDocument;
@class ResultCalc;
@class SummaryForEachPatient;


@interface MainRoutine : NSObject {
    // Store into MINtS file.
    NSMutableDictionary *mainMutDictionary;
    NSMutableArray *summaryForEachPatientMutAr;
    NSInteger selectedPatientRowNo;

    // summaryForEachPatient is required for temporary storage.
    SummaryForEachPatient *summaryForEachPatient;
    ResultCalc *resultCalc;
    NSArray *expandedTemporaryFilesFullPathAr;
    NSMutableArray *mutDomains;

    // Interconnections of objects
    MintsDocument *mainDocument;
}

-( BOOL )execute;
-( NSMutableArray *)setUpMutDomainsMutAr;
//-( BOOL )pickupMatches:( NSString * )tFastqFileR1R2;
// sendFile1, senFile2 have ..../.../lastPathComponent.fastq format
//-( NSString * )mergeR1R2;
//
//-( NSArray * )merge:( NSString * )nsSeq1 of:( NSString * )nsQuality1 with:( NSString * )nsSeq2 of:( NSString * )nsQuality2;
-( void )summarizeResult;
-( id )initWithDocument:( MintsDocument * )document;
-( void )pickupMatchesWithCoreSeq:( char ** )header R1Seq:( char ** )r1Seq R2Seq:( char ** )r2Seq R1Qual:( char ** )r1Qual R2Qual:( char ** )r2Qual file:( FILE * )outFailedToBeAssignedReads
                            queue:( dispatch_queue_t ) myQueue;
-( BOOL )prepareSeqR1andR2andCallPickupMatches;

@property    NSMutableDictionary *mainMutDictionary;
@property    NSMutableArray *summaryForEachPatientMutAr;
@property    NSInteger selectedPatientRowNo;
@property    SummaryForEachPatient *summaryForEachPatient;
@property    NSArray *expandedTemporaryFilesFullPathAr;
@property    MintsDocument *mainDocument;
@property    NSMutableArray *mutDomains;

@end
