//
//  MutDomain.h
//  MINtS analyzer
//
//  Created by 萩原 弘一 on 2013/09/05.
//  Copyright (c) 2013年 萩原 弘一. All rights reserved.
//
/* Copyright 2016 Koichi Hagiwara
 This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#import <Foundation/Foundation.h>

@interface MutDomain : NSObject < NSCopying, NSCoding > {
    NSString *name;
    NSString *type;
    NSMutableArray *mutationMutAr;  // Object at index 0 contains information for normal or allelic type for germline
    bool canStopSearchIfMatched;
    NSInteger   totalNumberOfNormalReads;
    NSInteger   totalNumberOfMutantReads;
}
-( id )init;
-( id )copyWithZone:( NSZone * )zone;
-( void )encodeWithCoder:( NSCoder * )aCoder;
-( id )initWithCoder:( NSCoder * )aDecoder;

@property   NSString *name;
@property   NSString *type;
@property   NSMutableArray *mutationMutAr;
@property   bool canStopSearchIfMatched;
@property   NSInteger   totalNumberOfNormalReads;
@property   NSInteger   totalNumberOfMutantReads;
@end
