//
//  MutDomain.m
//  MINtS analyzer
//
//  Created by 萩原 弘一 on 2013/09/05.
//  Copyright (c) 2013年 萩原 弘一. All rights reserved.
//
/* Copyright 2016 Koichi Hagiwara
 This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#import "MutDomain.h"

@implementation MutDomain
@synthesize name;
@synthesize type;
@synthesize mutationMutAr;
@synthesize canStopSearchIfMatched;
@synthesize totalNumberOfNormalReads;
@synthesize totalNumberOfMutantReads;

-( id )init {
    self = [ super init ];
    if( self ) {
        totalNumberOfNormalReads = 0;
        totalNumberOfMutantReads = 0;
    }
    return self;
}

-( id )copyWithZone:( NSZone * )zone {
    MutDomain *tempCopy = [ [ [ self class ] allocWithZone:zone ] init ];
    if( tempCopy ) {
        tempCopy.name = [ name copyWithZone:zone ];
        tempCopy.type = [ type copyWithZone:zone ];
        tempCopy.mutationMutAr = [ mutationMutAr copyWithZone:zone ];
        tempCopy.canStopSearchIfMatched = canStopSearchIfMatched;
        tempCopy.totalNumberOfNormalReads = totalNumberOfNormalReads;
        tempCopy.totalNumberOfMutantReads = totalNumberOfMutantReads;
    }
    return tempCopy;
}

-( void )encodeWithCoder:( NSCoder * )aCoder {
    [ aCoder encodeObject:name forKey:@"name" ];
    [ aCoder encodeObject:type forKey:@"type" ];
    [ aCoder encodeObject:mutationMutAr forKey:@"mutationMutAr" ];
    [ aCoder encodeBool:canStopSearchIfMatched forKey:@"canStopSearchIfMatched" ];
    [ aCoder encodeInt64:totalNumberOfNormalReads forKey:@"totalNumberOfNormalReads" ];
    [ aCoder encodeInt64:totalNumberOfMutantReads forKey:@"totalNumberOfMutantReads" ];
}

-( id )initWithCoder:( NSCoder * )aDecoder {
    self = [ super init ];
    name = [ aDecoder decodeObjectForKey:@"name" ];
    type = [ aDecoder decodeObjectForKey:@"type" ];
    mutationMutAr = [ aDecoder decodeObjectForKey:@"mutationMutAr" ];
    canStopSearchIfMatched = [ aDecoder decodeBoolForKey:@"canStopSearchIfMatched" ];
    totalNumberOfNormalReads = [ aDecoder decodeInt64ForKey:@"totalNumberOfNormalReads" ];
    totalNumberOfMutantReads = [ aDecoder decodeInt64ForKey:@"totalNumberOfMutantReads" ];
    return self;
}

@end
