//
//  Mutation.h
//  MainRoutine
//
//  Created by 萩原 弘一 on 2013/09/02.
//  Copyright (c) 2013年 萩原 弘一. All rights reserved.
//
/* Copyright 2016 Koichi Hagiwara
 This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#import <Foundation/Foundation.h>

@interface Mutation : NSObject < NSCopying, NSCoding >{
//  Mutation object at index 0 contains normal sequence.
    NSString *name;
    double referenceFrequencyOfTheMutantReads;
    double allowableFalsePositiveRate;
    double allowableFalseNegativeRate;
    NSInteger minimumRequiredNumberOfInformativeReads;
    NSString *seq;
    char *seqC;
    bool seqContainsWildCard;
    NSString *coreSeq;  // before10bp..after10bp, i.e. full query
    char *coreSeqC;
    bool coreSeqContainsWildCard;
    NSString *before10bp;
    NSString *after10bp;
    NSString *strandRequiredToRead;
    // Mapping section
    long match;         // Number of reads that do not completely match but match to the reference
    // Result section
    NSString *posNegDetectedOrAlleleType;      // "Negative", "Positive", "NA *x"
    NSString *mutantCellRatio;
    NSString *comment;
}
-( id )init;
-( id )copyWithZone:( NSZone * )zone;
-( void )encodeWithCoder:( NSCoder * )aCoder;
-( id )initWithCoder:( NSCoder * )aDecoder;

@property   NSString *name;
@property   double referenceFrequencyOfTheMutantReads;
@property   double allowableFalsePositiveRate;
@property   double allowableFalseNegativeRate;
@property   NSInteger minimumRequiredNumberOfInformativeReads;
@property   NSString *seq;
@property   char *seqC;
@property   bool seqContainsWildCard;
@property   NSString *coreSeq;
@property   char *coreSeqC;
@property   bool coreSeqContainsWildCard;
@property   NSString *before10bp;
@property   NSString *after10bp;
@property   NSString *strandRequiredToRead;
@property   long match;
@property   NSString *posNegDetectedOrAlleleType;
@property   NSString *mutantCellRatio;
@property   NSString *comment;
@end
