#include <stdio.h>
#import <Cocoa/Cocoa.h>
#import "MINtS analyzer.h"
/* Copyright 2016 Koichi Hagiwara
 This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

char *rcC( char *str ) {
    char *rcStr = malloc( strlen( str ) + 1 );
    long len = strlen( str );
    long i;
    for( i = 0; i < len; ++i ){
        rcStr[ i ] = str[ len - i - 1 ];
    }
    rcStr[ len ] = 0;
    for( i = 0; i < len; ++i ){
        if( toupper( rcStr[ i ] ) == 'A' ){ rcStr[ i ] = 'T'; }
        else if( toupper( rcStr[ i ] ) == 'G' ){ rcStr[ i ] = 'C'; }
        else if( toupper( rcStr[ i ] ) == 'C' ){ rcStr[ i ] = 'G'; }
        else if( toupper( rcStr[ i ] ) == 'T' ){ rcStr[ i ] = 'A'; }
        else { rcStr[ i ] = 'N'; }
    }
    strcpy( str, rcStr );
    free( rcStr );
    return str;
}

char *reverseC( char *str ){
    char *revStr = malloc( strlen( str ) + 1 );
    long len = strlen( str );
    long i;
    for( i = 0; i < len; ++i ){
        revStr[ i ] = str[ len - i - 1 ];
    }
    revStr[ len ] = 0;
    strcpy( str, revStr );
    free( revStr );
    return str;
}


char *myFgets( char * str, int size, FILE * stream ) {
	int i, character, nextCharacter;
	
	for ( i = character = 0; i < size; ++i ){
		character = fgetc( stream );
		switch( character ) {
			case	EOF:
				str[ i ]=( char )0;
				if ( str[ 0 ] == 0 )
					return ( NULL );
				else
					return( str );
			case	CR:	//	Mac and Windows.
				nextCharacter = fgetc( stream );
				switch ( nextCharacter ) {
					case	EOF:
						str[ i ]=( char )0;
						if ( str[ 0 ] == 0 )
							return ( NULL );
						else
							return( str );
					case	LF:
						str[ i ] = ( char )0;
						return( str );
					default:
						ungetc( nextCharacter, stream );
						str[ i ] = ( char )0;
						return( str );
				}
			case	LF:	//	Unix
				str[ i ]=( char )0;
				return( str );
			default:
				str[ i ] = character;
				break;
		}
	}
	str[ i ]=( char )0;
	return( NULL );
}

char *nucStrstr( const char *s1, const char *s2 ) {
    char *p;
    long s1len = strlen( s1 );
    long s2len = strlen( s2 );
    if( s1len < s2len ) {
        return NULL;
    }
    if( ( p = strstr( s1, s2 ) ) == NULL ) return NULL;
    return p;
}

char *nucStrstrT( const char *s1, const char *query, const char *qs1, const char threshold ) {
    char *p;
    unsigned long i;
    unsigned long start;
    unsigned long length;
    unsigned long s1Len = strlen( s1 );
    unsigned long sQueryLen = strlen( query );
    if( s1Len < sQueryLen ) {
        return NULL;
    }
    if( ( p = strstr( s1, query ) ) == NULL ) return NULL;
    start = s1 - p;
    length = strlen( query );
    for( i = start; i < length; ++i ){
        if( *( qs1 + i ) < threshold ) return NULL;
    }
    return p;
}

char *nucStrstrWildCardT( const char *s1, const char *query, const char *qs1, const char threshold ) {
    unsigned long i, j, k, l;
    unsigned long s1Len = strlen( s1 );
    unsigned long sQueryLen = strlen( query );
    if( s1Len < sQueryLen ) {
        return NULL;
    }
    for( i = 0; i < s1Len - sQueryLen + 1; ++i ) {
        for( j = i, k = 0; k < sQueryLen; ++j, ++k ) {
            char c1 = s1[ j ];
            char c2 = query[ k ];
            if( c1 == c2 ) {
                continue;
            }
            if( ( ( c1 == 'A' ) || ( c1 == 'G' ) || ( c1 == 'C' ) || ( c1 == 'T' ) ) && ( ( c2 == 'A' ) || ( c2 == 'G' ) || ( c2 == 'C' ) || ( c2 == 'T' ) ) ) {
                break;
            }
            if( 
               ( ( c1 == 'M' ) && ( ( c2 == 'A' ) || ( c2 == 'C' ) ) ) ||
               ( ( c1 == 'W' ) && ( ( c2 == 'A' ) || ( c2 == 'T' ) ) ) ||
               ( ( c1 == 'R' ) && ( ( c2 == 'A' ) || ( c2 == 'G' ) ) ) ||
               ( ( c1 == 'K' ) && ( ( c2 == 'G' ) || ( c2 == 'T' ) ) ) ||
               ( ( c1 == 'S' ) && ( ( c2 == 'G' ) || ( c2 == 'C' ) ) ) ||
               ( ( c1 == 'Y' ) && ( ( c2 == 'C' ) || ( c2 == 'T' ) ) ) ||
               ( ( c1 == 'D' ) && ( ( c2 == 'A' ) || ( c2 == 'G' ) || ( c2 == 'T' ) ) ) ||
               ( ( c1 == 'H' ) && ( ( c2 == 'A' ) || ( c2 == 'C' ) || ( c2 == 'T' ) ) ) ||
               ( ( c1 == 'B' ) && ( ( c2 == 'C' ) || ( c2 == 'G' ) || ( c2 == 'T' ) ) ) ||
               ( ( c1 == 'V' ) && ( ( c2 == 'A' ) || ( c2 == 'C' ) || ( c2 == 'G' ) ) ) ||
               ( ( c2 == 'M' ) && ( ( c1 == 'A' ) || ( c1 == 'C' ) ) ) ||
               ( ( c2 == 'W' ) && ( ( c1 == 'A' ) || ( c1 == 'T' ) ) ) ||
               ( ( c2 == 'R' ) && ( ( c1 == 'A' ) || ( c1 == 'G' ) ) ) ||
               ( ( c2 == 'K' ) && ( ( c1 == 'G' ) || ( c1 == 'T' ) ) ) ||
               ( ( c2 == 'S' ) && ( ( c1 == 'G' ) || ( c1 == 'C' ) ) ) ||
               ( ( c2 == 'Y' ) && ( ( c1 == 'C' ) || ( c1 == 'T' ) ) ) ||
               ( ( c2 == 'D' ) && ( ( c1 == 'A' ) || ( c1 == 'G' ) || ( c2 == 'T' ) ) ) ||
               ( ( c2 == 'H' ) && ( ( c1 == 'A' ) || ( c1 == 'C' ) || ( c2 == 'T' ) ) ) ||
               ( ( c2 == 'B' ) && ( ( c1 == 'C' ) || ( c1 == 'G' ) || ( c2 == 'T' ) ) ) ||
               ( ( c2 == 'V' ) && ( ( c1 == 'A' ) || ( c1 == 'C' ) || ( c2 == 'G' ) ) ) ) {
                continue;
            } else {
                break;
            }
        }
        if( k != sQueryLen ){
            continue;
        }
        for( l = i; l < sQueryLen; ++l ){
            if( *( qs1 + l ) < threshold ){
                return NULL;
            }
        }
        return( ( char * )( &( s1[ i ] ) ) );
    }
    return NULL;
}

char *nucStrstrWildCard( const char *s1, const char *s2 ) {
    long i, j, k;
    long s1len = strlen( s1 );
    long s2len = strlen( s2 );
    
    if( s1len < s2len ) {
        return NULL;
    }
    for( i = 0; i < s1len - s2len + 1; ++i ) {
        for( j = i, k = 0; k < s2len; ++j, ++k ) {
            char c1 = s1[ j ];
            char c2 = s2[ k ];
            if( c1 == c2 ) {
                continue;
            }
            if( ( ( c1 == 'A' ) || ( c1 == 'G' ) || ( c1 == 'C' ) || ( c1 == 'T' ) ) && ( ( c2 == 'A' ) || ( c2 == 'G' ) || ( c2 == 'C' ) || ( c2 == 'T' ) ) ) {
                break;
            }
            if(
               ( ( c1 == 'M' ) && ( ( c2 == 'A' ) || ( c2 == 'C' ) ) ) ||
               ( ( c1 == 'W' ) && ( ( c2 == 'A' ) || ( c2 == 'T' ) ) ) ||
               ( ( c1 == 'R' ) && ( ( c2 == 'A' ) || ( c2 == 'G' ) ) ) ||
               ( ( c1 == 'K' ) && ( ( c2 == 'G' ) || ( c2 == 'T' ) ) ) ||
               ( ( c1 == 'S' ) && ( ( c2 == 'G' ) || ( c2 == 'C' ) ) ) ||
               ( ( c1 == 'Y' ) && ( ( c2 == 'C' ) || ( c2 == 'T' ) ) ) ||
               ( ( c1 == 'D' ) && ( ( c2 == 'A' ) || ( c2 == 'G' ) || ( c2 == 'T' ) ) ) ||
               ( ( c1 == 'H' ) && ( ( c2 == 'A' ) || ( c2 == 'C' ) || ( c2 == 'T' ) ) ) ||
               ( ( c1 == 'B' ) && ( ( c2 == 'C' ) || ( c2 == 'G' ) || ( c2 == 'T' ) ) ) ||
               ( ( c1 == 'V' ) && ( ( c2 == 'A' ) || ( c2 == 'C' ) || ( c2 == 'G' ) ) ) ||
               ( ( c2 == 'M' ) && ( ( c1 == 'A' ) || ( c1 == 'C' ) ) ) ||
               ( ( c2 == 'W' ) && ( ( c1 == 'A' ) || ( c1 == 'T' ) ) ) ||
               ( ( c2 == 'R' ) && ( ( c1 == 'A' ) || ( c1 == 'G' ) ) ) ||
               ( ( c2 == 'K' ) && ( ( c1 == 'G' ) || ( c1 == 'T' ) ) ) ||
               ( ( c2 == 'S' ) && ( ( c1 == 'G' ) || ( c1 == 'C' ) ) ) ||
               ( ( c2 == 'Y' ) && ( ( c1 == 'C' ) || ( c1 == 'T' ) ) ) ||
               ( ( c2 == 'D' ) && ( ( c1 == 'A' ) || ( c1 == 'G' ) || ( c2 == 'T' ) ) ) ||
               ( ( c2 == 'H' ) && ( ( c1 == 'A' ) || ( c1 == 'C' ) || ( c2 == 'T' ) ) ) ||
               ( ( c2 == 'B' ) && ( ( c1 == 'C' ) || ( c1 == 'G' ) || ( c2 == 'T' ) ) ) ||
               ( ( c2 == 'V' ) && ( ( c1 == 'A' ) || ( c1 == 'C' ) || ( c2 == 'G' ) ) ) ) {
                continue;
            } else {
                break;
            }
        }
        if( k == s2len ){
            return ( char * )( &( s1[ i ] ) );
        }
    }
    return NULL;
}


