//
//  MintsDocument
//  MINtS analyzer
//
//  Created by 萩原 弘一 on 2013/09/05.
//  Copyright (c) 2013年 萩原 弘一. All rights reserved.
//
/* Copyright 2016 Koichi Hagiwara
 This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#import <Cocoa/Cocoa.h>
@class WindowController;
@class MutDomain;
@class NSDataCategory;
@class MainRoutine;

@interface MintsDocument : NSDocument {
    WindowController *windowController;
    MainRoutine *mainRoutine;
    bool cancelOperationFlag;
    dispatch_queue_t dispatchSerialQueueForAnalyzeAll;
    dispatch_queue_t dispatchSerialQueueForAnalyze;
    NSString *file1;
    NSString *file2;
    NSString *fastqFileDir;
    bool canMakeSummaryTable;
}

-( void )analyze:( id )sender;
-( void )analyzeAll:( id )sender;
-( void )copy:( id )sender;
-( void )doubleClickAction:( id )sender;
-( void )displayError:( NSString * )message;

@property WindowController *windowController;
@property MainRoutine *mainRoutine;
@property bool cancelOperationFlag;
@property    NSString *file1;
@property    NSString *file2;
@property    NSString *fastqFileDir;
@property    bool canMakeSummaryTable;

@end
