//
//  Document.m
//  MINtS analyzer
//
//  Created by 萩原 弘一 on 2013/09/05.
//  Copyright (c) 2013年 萩原 弘一. All rights reserved.
//
/* Copyright 2016 Koichi Hagiwara
 This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#import "MINtS analyzer.h"

@implementation MintsDocument
@synthesize windowController;
@synthesize mainRoutine;
@synthesize cancelOperationFlag;
@synthesize file1;
@synthesize file2;
@synthesize fastqFileDir;
@synthesize canMakeSummaryTable;

-( IBAction )makeSummaryTable:( id )sender {
    int i, j, k, l, m;
    NSMutableString *tMutS = [ NSMutableString stringWithCapacity:10 ];
    [ tMutS appendString:@"File\tMutation\tMutantCellPercent or Read#\tND *1\tOAZ-1 reads\tBIM type\n" ];
//    NSString *tempSt;
    NSString *nd1;
//    NSString *positives;
    for( i = 0; i < [ mainRoutine.summaryForEachPatientMutAr count ]; ++i ) {
        SummaryForEachPatient *tSummaryForEachPatient = mainRoutine.summaryForEachPatientMutAr[ i ];
        ReportGermlineDNA *tReportGermlineDNA = tSummaryForEachPatient.germlineDNAResultMutAr[ 0 ];
        ReportGermlineRNA *tReportGermlineRNA = tSummaryForEachPatient.germlineRNAResultMutAr[ 0 ];
        NSString *filePath = [ NSString stringWithFormat:@"%@/%@", [ tSummaryForEachPatient.fastqFileDir lastPathComponent ], tSummaryForEachPatient.file1 ];
        NSString *bimAllelicType = tReportGermlineDNA.allelicType;
        NSString *oaz1reads = tReportGermlineRNA.numberOfReads;
        k = 0;
        NSMutableString *tMutS2 = [ NSMutableString stringWithCapacity:10 ];
        l = 0;
        for( j = 0; j < [ tSummaryForEachPatient.somaticDNAResultMutAr count ]; ++j ){
            ReportSomaticDNA *tReportSomaticDNA = tSummaryForEachPatient.somaticDNAResultMutAr[ j ];
            if( [ tReportSomaticDNA.diagnosis isEqualToString:@"ND *1" ] ) {
                if( l == 0 ){
                    [ tMutS2 appendString:tReportSomaticDNA.areaSearched ];
                    l++;
                } else {
                    [ tMutS2 appendString:@", " ];
                    [ tMutS2 appendString:tReportSomaticDNA.areaSearched ];
                }
            }
        }
        nd1 = tMutS2;
        m = 0;
        NSMutableString *tMutPositives = [ NSMutableString stringWithCapacity:10 ];
        NSMutableString *tMutMutantCellRatio = [ NSMutableString stringWithCapacity:10 ];
        for( j = 0; j < [ tSummaryForEachPatient.somaticDNAResultMutAr count ]; ++j ){
            ReportSomaticDNA *tReportSomaticDNA = tSummaryForEachPatient.somaticDNAResultMutAr[ j ];
            if( [ tReportSomaticDNA.diagnosis isEqualToString:@"Positive" ] ) {
                if( m == 0 ){
                    [ tMutPositives appendString:tReportSomaticDNA.areaSearched ];
                    [ tMutMutantCellRatio appendString:tReportSomaticDNA.mutantCellRatio ];
                    m++;
                } else {
                    [ tMutPositives appendString:@", " ];
                    [ tMutPositives appendString:tReportSomaticDNA.areaSearched ];
                    [ tMutMutantCellRatio appendString:@", " ];
                    [ tMutMutantCellRatio appendString:tReportSomaticDNA.mutantCellRatio ];
                }
            }
        }
        for( j = 0; j < [ tSummaryForEachPatient.somaticRNAResultMutAr count ]; ++j ){
            ReportSomaticRNA *tReportSomaticRNA = tSummaryForEachPatient.somaticRNAResultMutAr[ j ];
            if( [ tReportSomaticRNA.diagnosis isEqualToString:@"Positive" ] ) {
                if( m == 0 ){
                    [ tMutPositives appendString:tReportSomaticRNA.gene ];
                    [ tMutMutantCellRatio appendString:tReportSomaticRNA.numberOfReads ];
                    ++m;
                } else {
                    [ tMutPositives appendString:@", " ];
                    [ tMutPositives appendString:tReportSomaticRNA.gene ];
                    [ tMutMutantCellRatio appendString:@", " ];
                    [ tMutMutantCellRatio appendString:tReportSomaticRNA.numberOfReads ];
                }
            }
        }
        if( [ tMutPositives isEqualToString:@"" ] ){
            [ tMutPositives appendString:@"Negative" ];
        }
        [ tMutS appendString:[ NSString stringWithFormat:@"%@\t%@\t%@\t%@\t%@\t%@\n", filePath, tMutPositives,tMutMutantCellRatio, nd1, oaz1reads, bimAllelicType ] ];
        
/*        for( j = 0; j < [ tSummaryForEachPatient.somaticDNAResultMutAr count ]; ++j ){
            ReportSomaticDNA *tReportSomaticDNA = tSummaryForEachPatient.somaticDNAResultMutAr[ j ];
            NSString *tMutantCellRatio = tReportSomaticDNA.mutantCellRatio;
            NSString *tAreaSearched = tReportSomaticDNA.areaSearched;
            if( [ tReportSomaticDNA.diagnosis isEqualToString:@"Positive" ] ) {
                if( k == 0 ){
                    tempSt = [ NSString stringWithFormat:@"%@\t%@\t%@\t%@\t%@\t%@\n", filePath, tAreaSearched,tMutantCellRatio, nd1, oaz1reads, bimAllelicType ];
                    ++k;
                    [ tMutS appendString:tempSt ] ;
                } else {
                    tempSt = [ NSString stringWithFormat:@"\t%@\t%@\t\t\t\n", tAreaSearched,tMutantCellRatio ];
                    [ tMutS appendString:tempSt ] ;
                }
            }
        }
        for( j = 0; j < [ tSummaryForEachPatient.somaticRNAResultMutAr count ]; ++j ){
            ReportSomaticRNA *tReportSomaticRNA = tSummaryForEachPatient.somaticRNAResultMutAr[ j ];
            NSString *tGene = tReportSomaticRNA.gene;
            NSString *tNumberOfReads = tReportSomaticRNA.numberOfReads;
            if( [ tReportSomaticRNA.diagnosis isEqualToString:@"Positive" ] ) {
                if( k == 0 ){
                    tempSt = [ NSString stringWithFormat:@"%@\t%@\t%@\t%@\t%@\t%@\n", filePath, tGene,tNumberOfReads, nd1, oaz1reads, bimAllelicType ];
                    ++k;
                    [ tMutS appendString:tempSt ] ;
                } else {
                    tempSt = [ NSString stringWithFormat:@"\t%@\t%@\t\t\t\n", tGene,tNumberOfReads ];
                    [ tMutS appendString:tempSt ] ;
                }
            }
        }
        if( k == 0 ){
            tempSt = [ NSString stringWithFormat:@"%@\tNegative\t\t%@\t%@\t%@\n", filePath, nd1, oaz1reads, bimAllelicType ];
            [ tMutS appendString:tempSt ] ;
        }
 */
    }

    NSPasteboard *pasteBoard = [ NSPasteboard generalPasteboard ];
    [ pasteBoard declareTypes:[ NSArray arrayWithObjects:NSStringPboardType, nil ] owner:nil ];
    [ pasteBoard setString:tMutS forType:NSStringPboardType ];
}

// Disable saving of MINtS file while executing analysis.
-( BOOL )validateUserInterfaceItem:( id < NSValidatedUserInterfaceItem > )anItem {
    SEL theAction = [ anItem action ];
    BOOL result = NO;
    if( theAction == @selector( saveMINtSFile: ) ){
        if( [ windowController.analyzeButton isEnabled ] == NO ){
            result = NO;
        } else {
            result = YES;
        }
    } else if( theAction == @selector( makeSummaryTable: ) ){
        result = canMakeSummaryTable;
    }
    return result;
}

// mainRoutine.mainMutDictionary should contain summaryForEachPatientMutAr and selectedPatientRowNo.
-( IBAction )saveMINtSFile:( id )sender {
    mainRoutine.mainMutDictionary = [ [ NSMutableDictionary alloc ] initWithCapacity:3 ];
    [ mainRoutine.mainMutDictionary setObject:mainRoutine.summaryForEachPatientMutAr forKey:@"summaryForEachPatientMutAr" ];
    [ mainRoutine.mainMutDictionary setObject:[ NSNumber numberWithInteger:mainRoutine.selectedPatientRowNo ] forKey:@"selectedPatientRowNo" ];
    NSData *tData = [ NSKeyedArchiver archivedDataWithRootObject:mainRoutine.mainMutDictionary ];
    NSSavePanel *savePanel = [ NSSavePanel savePanel ];
    [ savePanel setAllowedFileTypes:[ [ NSArray alloc ] initWithObjects:@"mints", nil ] ];
    [ savePanel beginSheetModalForWindow:windowController.mainWindow completionHandler:^( NSInteger result ) {
        if ( result == NSOKButton ) {
            NSURL *url = [ savePanel URL ];
            [ tData writeToURL:url atomically:YES ];
        }
    }];
}

-( id )init {
    self = [ super init ];
    if( self ) {
        dispatchSerialQueueForAnalyzeAll = dispatch_queue_create( "com.hagiwark", NULL );
        dispatchSerialQueueForAnalyze = dispatch_queue_create( "com.hagiwark", NULL );
        mainRoutine = [ [ MainRoutine alloc ] initWithDocument:self ]; // MainRoutine class is an agent-like class of MintsDocument class and removed from the MintsDocument class because of clarification.
        canMakeSummaryTable = NO;
    }
    return self;
}

-( void )analyzeAll:( id )sender {
    // Unable buttons
    [ self disableControles ];
    cancelOperationFlag = NO;   // cancelOperationFlag becomes YES when command-. is pressed.
    
    // Obtain directory content
    NSInteger i, j;
    NSFileManager *tFileManager = [ NSFileManager defaultManager ];
    NSMutableArray *tDirectoryContent = [ NSMutableArray arrayWithArray:[ tFileManager contentsOfDirectoryAtPath:fastqFileDir error:nil ] ];
    for( i = 0; i < [ tDirectoryContent count ]; ++i ) {
        NSString *tSt = tDirectoryContent[ i ];
        if( [ tSt characterAtIndex:0 ] == '_' || [ tSt characterAtIndex:0 ] == '.' ) {
            [ tDirectoryContent replaceObjectAtIndex:i withObject:@"" ];
        }
    }
    [ tDirectoryContent removeObjectIdenticalTo:@"" ];
    NSMutableArray *entryMutAr = [ NSMutableArray arrayWithCapacity:( NUMBER_OF_PATIENTS_PER_KIT + 1 ) ];
    for( i = 0; i <= NUMBER_OF_PATIENTS_PER_KIT; ++i ) {
        [ entryMutAr addObject:[ NSMutableArray arrayWithObjects:@"", @"", [ NSNumber numberWithInteger:0 ], nil ] ];
    }
    for( i = 1; i <= NUMBER_OF_PATIENTS_PER_KIT; ++i ) {
        NSString *keyStringR1 = [ NSString stringWithFormat:@"_S%ld_L001_R1_001.fastq", i ];
        NSString *keyStringR2 = [ NSString stringWithFormat:@"_S%ld_L001_R2_001.fastq", i ];
        for( j = 0; j < [ tDirectoryContent count ]; ++j ) {
            NSString *content = tDirectoryContent[ j ];
            if( [ content rangeOfString:keyStringR1 ].location != NSNotFound ) {
                entryMutAr[ i ][ 0 ] = content; continue;
            }
            if( [ content rangeOfString:keyStringR2 ].location != NSNotFound ) {
                entryMutAr[ i ][ 1 ] = content; continue;
            }
        }
        entryMutAr[ i ][ 2 ] = [ NSNumber numberWithInteger:i ];
    }
    for( i = 0; i <= NUMBER_OF_PATIENTS_PER_KIT; ++i ) {
        if( [ entryMutAr[ i ][ 0 ] isEqualToString:@"" ] && [ entryMutAr[ i ][ 1 ] isEqualToString:@"" ] ) {
            entryMutAr[ i ] = @"";
        }
    }
    [ entryMutAr removeObjectIdenticalTo:@"" ];
    for( i = 0; i < [ entryMutAr count ]; ++i ) {
        if( [ entryMutAr[ i ][ 0 ] isEqualToString:@"" ] || [ entryMutAr[ i ][ 1 ] isEqualToString:@"" ] ) {
            [ [ NSAlert alertWithMessageText:[ NSString stringWithFormat:@"Patient %ld has unpaired fastq file.", [ entryMutAr[ i ][ 2 ] integerValue ] ] defaultButton:@"OK" alternateButton:nil otherButton:nil informativeTextWithFormat:@"" ] runModal ];
            [ self enableControles ];
            return;
        }
    }
    // Window is updated according to the information in mainRoutine.summaryForEachPatient except for patientsNoTextView when  mainRoutine.selectedPatientRowNo = -1.
    mainRoutine.selectedPatientRowNo = -1;
    mainRoutine.summaryForEachPatient = [ [ SummaryForEachPatient alloc ] initWithMutDomains:mainRoutine.mutDomains ];
    [ windowController updateWindowFromSummaryForEachPatient:mainRoutine.summaryForEachPatient ];

    // Reset storage.
    mainRoutine.summaryForEachPatientMutAr = [ [ NSMutableArray alloc ] initWithCapacity:1 ];
    [ windowController.patientsNoTableView reloadData ]; // For resetting patientsNoTableView
    [ windowController.germlineDNAResultTableView reloadData ];
    [ windowController.somaticDNAResultTableView reloadData ];
    [ windowController.germlineRNAResultTableView reloadData ];
    [ windowController.somaticRNAResultTableView reloadData ];

    for( i = 0; i < [ entryMutAr count ]; ++ i ) {
        dispatch_async( dispatchSerialQueueForAnalyzeAll, ^{
            if( cancelOperationFlag == NO ){
                mainRoutine.expandedTemporaryFilesFullPathAr = [ self prepareFilesForMainRoutineUsingDir:fastqFileDir files:[ NSArray arrayWithObjects:entryMutAr[ i ][ 0 ], entryMutAr[ i ][ 1 ], nil ] ];
                // mainRoutine.summaryForEachPatient is used for temporary storage.
                mainRoutine.summaryForEachPatient = [ [ SummaryForEachPatient alloc ] initWithMutDomains:mainRoutine.mutDomains ];
                mainRoutine.summaryForEachPatient.file1 = [ entryMutAr[ i ][ 0 ] lastPathComponent ];
                mainRoutine.summaryForEachPatient.file2 = [ entryMutAr[ i ][ 1 ] lastPathComponent ];
                mainRoutine.summaryForEachPatient.fastqFileDir = fastqFileDir;
                NSArray *tFileNameComponent = [ mainRoutine.summaryForEachPatient.file1 componentsSeparatedByString:@"_S" ];
                NSArray *tFileNameComponent2 = [ tFileNameComponent[ 1 ] componentsSeparatedByString:@"_" ];
                NSString *tPtNo = tFileNameComponent2[ 0 ];
                mainRoutine.summaryForEachPatient.patientNo = tPtNo;

                // Renew only file names to be analyzed.
                [ windowController.file1TextField setStringValue:mainRoutine.summaryForEachPatient.file1 ];
                [ windowController.file2TextField setStringValue:mainRoutine.summaryForEachPatient.file2 ];
                BOOL result;
                @autoreleasepool {
                    result = [ mainRoutine execute ];
                }
                dispatch_async( dispatch_get_main_queue(), ^{
                    if( result == YES ) {
                        [ mainRoutine.summaryForEachPatientMutAr addObject:mainRoutine.summaryForEachPatient ];
                        canMakeSummaryTable = TRUE;
                        mainRoutine.selectedPatientRowNo = i;
                        [ windowController.patientsNoTableView reloadData ];
                        NSIndexSet *indexSet = [ [ NSIndexSet alloc ] initWithIndex:( NSUInteger )i ];
                        [ windowController.patientsNoTableView selectRowIndexes:indexSet byExtendingSelection:NO ];
                   } else {
                        [ self displayError:[ NSString stringWithFormat:@"Error occurred for files %@ and %@\n", mainRoutine.expandedTemporaryFilesFullPathAr[ 0 ], mainRoutine.expandedTemporaryFilesFullPathAr[ 1 ] ] ];
                    }
                    if( i == [ entryMutAr count ] - 1 ) {
                        [ self enableControles ];
                    }
                } );
            } else {
                dispatch_async( dispatch_get_main_queue(), ^{
                    [ self enableControles ];
                } );
            }
        } );
    }
    return;
}

-( void )analyze:( id )sender {
    // Initialization
    mainRoutine.summaryForEachPatient = [ [ SummaryForEachPatient alloc ] initWithMutDomains:mainRoutine.mutDomains ];
    mainRoutine.summaryForEachPatientMutAr = [ [ NSMutableArray alloc ] initWithCapacity:1 ];
    [ windowController.patientsNoTableView reloadData ]; // For resetting patientsNoTableView
    [ windowController.germlineDNAResultTableView reloadData ];
    [ windowController.somaticDNAResultTableView reloadData ];
    [ windowController.germlineRNAResultTableView reloadData ];
    [ windowController.somaticRNAResultTableView reloadData ];
    mainRoutine.summaryForEachPatient.file1 = file1;
    mainRoutine.summaryForEachPatient.file2 = file2;
    mainRoutine.summaryForEachPatient.fastqFileDir = fastqFileDir;
    NSArray *tFileNameComponent = [ [ file1 lastPathComponent ] componentsSeparatedByString:@"_S" ];
    NSArray *tFileNameComponent2 = [ tFileNameComponent[ 1 ] componentsSeparatedByString:@"_" ];
    NSString *tPtNo = tFileNameComponent2[ 0 ];
    mainRoutine.summaryForEachPatient.patientNo = tPtNo;
    mainRoutine.expandedTemporaryFilesFullPathAr = [ self prepareFilesForMainRoutineUsingDir:mainRoutine.summaryForEachPatient.fastqFileDir files:[ NSArray arrayWithObjects:mainRoutine.summaryForEachPatient.file1, mainRoutine.summaryForEachPatient.file2, nil ] ];
    // Window is updated according to the information in mainRoutine.summaryForEachPatient.
    mainRoutine.selectedPatientRowNo = -1;
    [ windowController updateWindowFromSummaryForEachPatient:mainRoutine.summaryForEachPatient ];
    [ self disableControles ];
    dispatch_async( dispatchSerialQueueForAnalyze, ^{
        BOOL result;
        result = [ mainRoutine execute ];
        dispatch_async( dispatch_get_main_queue(), ^{
            if( result == YES ) {
                [ self enableControles ];
                [ mainRoutine.summaryForEachPatientMutAr addObject:mainRoutine.summaryForEachPatient ];
                canMakeSummaryTable = TRUE;
                [ windowController.patientsNoTableView reloadData ];
                mainRoutine.selectedPatientRowNo = 0;
                NSIndexSet *indexSet = [ [ NSIndexSet alloc ] initWithIndex:( NSUInteger )0 ];
                [ windowController.patientsNoTableView selectRowIndexes:indexSet byExtendingSelection:NO ];
            } else {
                [ self displayError:[ NSString stringWithFormat:@"Error occurred for files %@ and %@\n", mainRoutine.expandedTemporaryFilesFullPathAr[ 0 ], mainRoutine.expandedTemporaryFilesFullPathAr[ 1 ] ] ];
            }
            // If called by pushing the button
        } );
    } );
}

-( void )doubleClickAction:( id )sender {
    NSInteger rowIndex = [ sender selectedRow ];
    NSTableColumn *tTableColumn = [ ( NSTableView * )sender tableColumnWithIdentifier:@"1" ];
    NSCell *cell = [ tTableColumn dataCellForRow: rowIndex ];
    NSRect cellRect = [ [ cell controlView ] bounds ];
    windowController.summaryForEachPatientUsedForPopover = mainRoutine.summaryForEachPatientMutAr[ mainRoutine.selectedPatientRowNo ];
    [ windowController.popoverCommentTextField setStringValue:@"" ];
    MutDomain *tMutDomain;
    if( sender == windowController.germlineDNAResultTableView ) {
        tMutDomain = [ windowController.summaryForEachPatientUsedForPopover.germlineDNAResultMutAr[ rowIndex ] mutDomain ];
    } else if( sender == windowController.somaticDNAResultTableView ) {
        tMutDomain = [ windowController.summaryForEachPatientUsedForPopover.somaticDNAResultMutAr[ rowIndex ] mutDomain ];
        NSString *comment = [ windowController.summaryForEachPatientUsedForPopover.somaticDNAResultMutAr[ rowIndex ] comment ];
        if( ![ comment isEqualToString:@"" ] ) {
            [ windowController.popoverCommentTextField setStringValue:[ NSString stringWithFormat:@"False positive rate = %@", comment ] ];
        }
    } else if( sender == windowController.germlineRNAResultTableView ) {
        tMutDomain = [ windowController.summaryForEachPatientUsedForPopover.germlineRNAResultMutAr[ rowIndex ] mutDomain ];
    } else if( sender == windowController.somaticRNAResultTableView ) {
        tMutDomain = [ windowController.summaryForEachPatientUsedForPopover.somaticRNAResultMutAr[ rowIndex ] mutDomain ];
    }
    windowController.mutDomainUsedForPopover = tMutDomain;
    [ windowController.popoverTableView reloadData ];
    [ windowController.popover showRelativeToRect: cellRect ofView:sender preferredEdge:NSMaxXEdge ];
}

-( void )copy:( id )sender {
    NSIndexSet *indexSet = [ windowController.patientsNoTableView selectedRowIndexes ];
    NSMutableArray *tMutAr = [ NSMutableArray arrayWithCapacity:1 ];
    NSUInteger firstIndex = [ indexSet firstIndex ], lastIndex = [ indexSet lastIndex ], i, j, k;
    for( i = firstIndex; i <= lastIndex; ++i ) {
        if( [ indexSet containsIndex: i ] == YES ) {
            [ tMutAr addObject:[ NSNumber numberWithInteger:i ] ];
        }
    }
    NSMutableString *logMutSt = [ [ NSMutableString alloc ] initWithCapacity:40 ];
    for( i = 0; i < [ tMutAr count ]; ++i ) {
        SummaryForEachPatient *tSummaryForEachPatient = mainRoutine.summaryForEachPatientMutAr[ [ tMutAr[ i ] integerValue ] ];
        [ logMutSt appendString:[ NSString stringWithFormat:@"%@\n", tSummaryForEachPatient.file1 ] ];
        [ logMutSt appendString:[ NSString stringWithFormat:@"%@\n", tSummaryForEachPatient.file2 ] ];
        [ logMutSt appendString:[ NSString stringWithFormat:@"TotalNumberOfReads\t%ld\n", tSummaryForEachPatient.totalNumberOfReads ] ];
        [ logMutSt appendString:[ NSString stringWithFormat:@"ReadsMapped\t%ld\n", tSummaryForEachPatient.readsMapped ] ];
        [ logMutSt appendString:[ NSString stringWithFormat:@"ReadsFailedToBeMapped\t%ld\n", tSummaryForEachPatient.readsFailedToBeMapped ] ];
        [ logMutSt appendString:@"\n" ]; // blank line
        for( j = 0; j < [ tSummaryForEachPatient.mutDomains count ]; ++j ) {
            MutDomain *tMutDomain = tSummaryForEachPatient.mutDomains[ j ];
            for( k = 0; k < [ tMutDomain.mutationMutAr count ]; ++k ) {
                Mutation *tMutation = tMutDomain.mutationMutAr[ k ];
                [ logMutSt appendString:[ NSString stringWithFormat:@"%@\t%ld\n", tMutation.name, tMutation.match ] ];
            }
        }
        [ logMutSt appendString:@"----------------------------\n" ];
    }
    [ logMutSt appendString:@"Patient #\t" ];
    SummaryForEachPatient *tSummaryForEachPatient = mainRoutine.summaryForEachPatientMutAr[ 0 ];
    for( i = 0; i < [ tSummaryForEachPatient.mutDomains count ]; ++i ) {
        MutDomain *tMutDomain = tSummaryForEachPatient.mutDomains[ i ];
        if( [ tMutDomain.type isEqualToString:@"Germline" ] ) {
            [ logMutSt appendString:[ NSString stringWithFormat:@"%@ wt\t", tMutDomain.name ] ];
            [ logMutSt appendString:[ NSString stringWithFormat:@"%@ mut\t", tMutDomain.name ] ];
        }
        if( [ tMutDomain.type isEqualToString:@"SomaticDNA" ] ) {
            [ logMutSt appendString:[ NSString stringWithFormat:@"%@ norm\t", tMutDomain.name ] ];
            [ logMutSt appendString:[ NSString stringWithFormat:@"%@ mut\t", tMutDomain.name ] ];
        }
        if( [ tMutDomain.type isEqualToString:@"germline_RNA" ] ) {
            [ logMutSt appendString:[ NSString stringWithFormat:@"%@\t", tMutDomain.name ] ];
        }
        if( [ tMutDomain.type isEqualToString:@"fusion_mRNA" ] ) {
            [ logMutSt appendString:[ NSString stringWithFormat:@"%@\t", tMutDomain.name ] ];
        }
    }
    [ logMutSt appendString:@"\n" ];

    for( i = 0; i < [ tMutAr count ]; ++i ) {
        SummaryForEachPatient *tSummaryForEachPatient = mainRoutine.summaryForEachPatientMutAr[ [ tMutAr[ i ] integerValue ] ];
        [ logMutSt appendString:[ NSString stringWithFormat:@"%@\t", tSummaryForEachPatient.patientNo ] ];
        for( j = 0; j < [ tSummaryForEachPatient.mutDomains count ]; ++j ) {
            MutDomain *tMutDomain = tSummaryForEachPatient.mutDomains[ j ];
            if( [ tMutDomain.type isEqualToString:@"Germline" ] ) {
                [ logMutSt appendString:[ NSString stringWithFormat:@"%ld\t%ld\t", tMutDomain.totalNumberOfNormalReads, tMutDomain.totalNumberOfMutantReads ] ];
            }
            if( [ tMutDomain.type isEqualToString:@"SomaticDNA" ] ) {
                [ logMutSt appendString:[ NSString stringWithFormat:@"%ld\t%ld\t", tMutDomain.totalNumberOfNormalReads, tMutDomain.totalNumberOfMutantReads ] ];
            }
            if( [ tMutDomain.type isEqualToString:@"germline_RNA" ] ) {
                [ logMutSt appendString:[ NSString stringWithFormat:@"%ld\t", tMutDomain.totalNumberOfNormalReads ] ];
            }
            if( [ tMutDomain.type isEqualToString:@"fusion_mRNA" ] ) {
                [ logMutSt appendString:[ NSString stringWithFormat:@"%ld\t", tMutDomain.totalNumberOfNormalReads + tMutDomain.totalNumberOfMutantReads ] ];
            }
        }
        [ logMutSt appendString:@"\n" ];
    }
    [ logMutSt appendString:@"----------------------------\n" ];
    [ logMutSt appendString:@"Patient#\tArea\tAllele Type\n" ];
    for( i = 0; i < [ tMutAr count ]; ++i ) {
        SummaryForEachPatient *tSummaryForEachPatient = mainRoutine.summaryForEachPatientMutAr[ [ tMutAr[ i ] integerValue ] ];
        NSMutableArray *tResultMutAr = tSummaryForEachPatient.germlineDNAResultMutAr;
        [ logMutSt appendString:[ NSString stringWithFormat:@"%@", tSummaryForEachPatient.patientNo ] ];
        for( j = 0; j < [ tResultMutAr count ]; ++j ) {
            ReportGermlineDNA *tRepGermlineDNA = tResultMutAr[ j ];
            [ logMutSt appendString:[ NSString stringWithFormat:@"\t%@\t%@\n", tRepGermlineDNA.areaSearched, tRepGermlineDNA.allelicType ] ];
        }
    }
    [ logMutSt appendString:@"Patient#\tArea\tDiagnosis\tMutantCellRatio\tFalsePositiveRate\n" ];
    for( i = 0; i < [ tMutAr count ]; ++i ) {
        SummaryForEachPatient *tSummaryForEachPatient = mainRoutine.summaryForEachPatientMutAr[ [ tMutAr[ i ] integerValue ] ];
        NSMutableArray *tResultMutAr = tSummaryForEachPatient.somaticDNAResultMutAr;
        [ logMutSt appendString:[ NSString stringWithFormat:@"%@", tSummaryForEachPatient.patientNo ] ];
        for( j = 0; j < [ tResultMutAr count ]; ++j ) {
            ReportSomaticDNA *tRepSomaticDNA = tResultMutAr[ j ];
            [ logMutSt appendString:[ NSString stringWithFormat:@"\t%@\t%@\t%@\t%@\n", tRepSomaticDNA.areaSearched, tRepSomaticDNA.diagnosis, tRepSomaticDNA.mutantCellRatio, tRepSomaticDNA.comment ] ];
        }
    }
    [ logMutSt appendString:@"Patient#\tArea\tAlleleType\n" ];
    for( i = 0; i < [ tMutAr count ]; ++i ) {
        SummaryForEachPatient *tSummaryForEachPatient = mainRoutine.summaryForEachPatientMutAr[ [ tMutAr[ i ] integerValue ] ];
        NSMutableArray *tResultMutAr = tSummaryForEachPatient.germlineDNAResultMutAr;
        [ logMutSt appendString:[ NSString stringWithFormat:@"%@", tSummaryForEachPatient.patientNo ] ];
        for( j = 0; j < [ tResultMutAr count ]; ++j ) {
            ReportGermlineDNA *tRepGermlineDNA = tResultMutAr[ j ];
            [ logMutSt appendString:[ NSString stringWithFormat:@"\t%@\t%@\n", tRepGermlineDNA.areaSearched, tRepGermlineDNA.allelicType ] ];
        }
    }
    [ logMutSt appendString:@"Patient#\tGene\tDiagnosis\tNumberOfReads\tComment\n" ];
    for( i = 0; i < [ tMutAr count ]; ++i ) {
        SummaryForEachPatient *tSummaryForEachPatient = mainRoutine.summaryForEachPatientMutAr[ [ tMutAr[ i ] integerValue ] ];
        NSMutableArray *tResultMutAr = tSummaryForEachPatient.germlineRNAResultMutAr;
        [ logMutSt appendString:[ NSString stringWithFormat:@"%@", tSummaryForEachPatient.patientNo ] ];
        for( j = 0; j < [ tResultMutAr count ]; ++j ) {
            ReportGermlineRNA *tRepGermlineRNA = tResultMutAr[ j ];
            [ logMutSt appendString:[ NSString stringWithFormat:@"\t%@\t%@\t%@\t%@\n", tRepGermlineRNA.gene, tRepGermlineRNA.diagnosis, tRepGermlineRNA.numberOfReads, tRepGermlineRNA.comment ] ];
        }
    }
    [ logMutSt appendString:@"Patient#\tGene\tDiagnosis\tNumberOfReads\tComment\n" ];
    for( i = 0; i < [ tMutAr count ]; ++i ) {
        SummaryForEachPatient *tSummaryForEachPatient = mainRoutine.summaryForEachPatientMutAr[ [ tMutAr[ i ] integerValue ] ];
        NSMutableArray *tResultMutAr = tSummaryForEachPatient.somaticRNAResultMutAr;
        [ logMutSt appendString:[ NSString stringWithFormat:@"%@", tSummaryForEachPatient.patientNo ] ];
        for( j = 0; j < [ tResultMutAr count ]; ++j ) {
            ReportSomaticRNA *tRepSomaticRNA = tResultMutAr[ j ];
            [ logMutSt appendString:[ NSString stringWithFormat:@"\t%@\t%@\t%@\t%@\n", tRepSomaticRNA.gene, tRepSomaticRNA.diagnosis, tRepSomaticRNA.numberOfReads, tRepSomaticRNA.comment ] ];
        }
    }
    NSPasteboard *pasteBoard = [ NSPasteboard generalPasteboard ];
    [ pasteBoard declareTypes:[ NSArray arrayWithObject:NSStringPboardType] owner:nil ];
    [ pasteBoard setString:logMutSt forType:NSStringPboardType ];
}

-( void )disableControles {
    [ windowController.analyzeButton setEnabled:NO ];
    [ windowController.analyzeAllButton setEnabled:NO ];
    [ windowController setValue:@YES forKey:@"indicator" ];
}
-( void )enableControles {
    [ windowController.analyzeButton setEnabled:YES ];
    [ windowController.analyzeAllButton setEnabled:YES ];
    [ windowController setValue:@NO forKey:@"indicator" ];
}

-( NSArray * )prepareFilesForMainRoutineUsingDir:( NSString * )fileDir files:( NSArray * )fileAr {
    NSInteger i;
    NSData *data;
    NSMutableArray *filesNamesBeingSentToMainRoutineMutAr = [ NSMutableArray arrayWithCapacity:2 ];
    NSTask *task;
    NSArray *argumantsAr;
    NSPipe *pipe;
    NSFileHandle *fileH;
    for( i = 0; i < 2; ++i ) {
        NSString *tFastqFileLastPathComponent = fileAr[ i ];
        if( [ [ tFastqFileLastPathComponent pathExtension ] isEqualToString:@"gz" ] ) {
            task = [ [ NSTask alloc ] init ];
            [ task setLaunchPath:@"/bin/sh" ];
            argumantsAr = [ NSArray arrayWithObjects:@"-c", [ NSString stringWithFormat:@"gunzip -c \"%@/%@\" > \"%@/_%@\"", fileDir,tFastqFileLastPathComponent, fileDir, [ tFastqFileLastPathComponent stringByDeletingPathExtension ] ], nil ];
            [ task setArguments:argumantsAr ];
            pipe = [ NSPipe pipe ];
            [ task setStandardOutput:pipe ];
            [ task setStandardOutput:pipe ];
            fileH = [ pipe fileHandleForReading ];
            [ task launch ];
            data = [ fileH readDataToEndOfFile ];
            [ filesNamesBeingSentToMainRoutineMutAr addObject:[ NSString stringWithFormat:@"%@/_%@", fileDir, [ tFastqFileLastPathComponent stringByDeletingPathExtension ] ] ];
        } else {
            data = [ NSData dataWithContentsOfURL:[ NSURL fileURLWithPath:[ NSString stringWithFormat:@"%@/%@", fileDir, tFastqFileLastPathComponent ] ] ];
            NSString *tSendFile = [ NSString stringWithFormat:@"%@/_%@", fileDir, tFastqFileLastPathComponent ];
            [ data writeToFile:tSendFile atomically:YES ];
            [ filesNamesBeingSentToMainRoutineMutAr addObject:[ NSString stringWithFormat:@"%@/_%@", fileDir, tFastqFileLastPathComponent ] ];
        }
    }
    return filesNamesBeingSentToMainRoutineMutAr;
}

-( void )makeWindowControllers {
    NSUserDefaults *defaults = [ NSUserDefaults standardUserDefaults ];
    if( [ [ defaults valueForKey:@"windowSizeMidi" ] boolValue ] == YES ) {
        windowController = [ [ WindowController alloc ] initWithWindowNibName:@"MintsDocumentMidi" ];        
    } else {
        windowController = [ [ WindowController alloc ] initWithWindowNibName:@"MintsDocument" ];
    }
    [ self addWindowController:windowController ];
    // Initialization of windowController's instance variables are done at this place.
    windowController.mintsDocument = self;
    windowController.totalNumberOfReads = @"";
    windowController.readsMapped = @"";
    windowController.readsFailedToBeMapped = @"";
    windowController.mainRoutine = mainRoutine;
}

+( BOOL )autosavesInPlace {
    return YES;
}

-( BOOL )readFromURL:( NSURL * )absoluteURL ofType:( NSString * )typeName error:( NSError ** )outError {
    NSFileManager *fileManager = [ NSFileManager defaultManager ];
    NSString *filePath = [ absoluteURL path ];
    if( [ typeName isEqualToString:@"MINtSFile" ] ) {
        NSData *tData = [ NSData dataWithContentsOfURL:absoluteURL ];
        NSMutableDictionary *tDic = [ NSKeyedUnarchiver unarchiveObjectWithData:tData ];
        mainRoutine.mainMutDictionary = tDic;
        mainRoutine.summaryForEachPatientMutAr = [ mainRoutine.mainMutDictionary objectForKey:@"summaryForEachPatientMutAr" ];
        mainRoutine.selectedPatientRowNo = [ [ mainRoutine.mainMutDictionary objectForKey:@"selectedPatientRowNo" ] integerValue ];
        if( [ mainRoutine.summaryForEachPatientMutAr count ] != 0 ) {
            canMakeSummaryTable = TRUE;
        }
        return YES;
    }
    NSString *tLastPathComponent = [ filePath lastPathComponent ];
    NSString *tFastqFile1LastPathComponent, *tFastqFile2LastPathComponent, *tFastqFileDir;
    tFastqFileDir = [ filePath stringByDeletingLastPathComponent ];
    //Program first search for a pair file with the same extention as indicated by the dialog.
    //If such files are not found, find a pair file with different extension.
    NSInteger tFileExistFlag = 0;
    if( [ tLastPathComponent rangeOfString:@"_R1_" ].location != NSNotFound ){
        NSArray *tAr = [ tLastPathComponent componentsSeparatedByString:@"_R1_" ];
        tFastqFile1LastPathComponent = [ filePath lastPathComponent ];
        tFastqFile2LastPathComponent = [ NSString stringWithFormat:@"%@_R2_%@", tAr[ 0 ], tAr[ 1 ] ];
        if( [ [ tFastqFile2LastPathComponent pathExtension ] isEqualToString:@"fastq" ] ) {
            if( [ fileManager fileExistsAtPath:[ NSString stringWithFormat:@"%@/%@", tFastqFileDir,tFastqFile2LastPathComponent ] ] ) {
                tFileExistFlag = 1;
            } else if( [ fileManager fileExistsAtPath:[ NSString stringWithFormat:@"%@/%@.gz", tFastqFileDir, tFastqFile2LastPathComponent ] ] ) {
                tFastqFile2LastPathComponent = [ NSString stringWithFormat:@"%@.gz", tFastqFile2LastPathComponent ];
                tFileExistFlag = 1;
            }
        } else if( [ [ tFastqFile2LastPathComponent pathExtension ] isEqualToString:@"gz" ] ) {
            if( [ fileManager fileExistsAtPath:[ NSString stringWithFormat:@"%@/%@", tFastqFileDir,tFastqFile2LastPathComponent ] ] ) {
                tFileExistFlag = 1;
            } else if( [ fileManager fileExistsAtPath:[ NSString stringWithFormat:@"%@/%@", tFastqFileDir, [ tFastqFile2LastPathComponent stringByDeletingPathExtension ] ] ] ) {
                tFastqFile2LastPathComponent = [ NSString stringWithFormat:@"%@", [ tFastqFile2LastPathComponent stringByDeletingPathExtension ] ];
                tFileExistFlag = 1;
            }
        }
    } else if( [ tLastPathComponent rangeOfString:@"_R2_" ].location != NSNotFound ){
        NSArray *tAr = [ tLastPathComponent componentsSeparatedByString:@"_R2_" ];
        tFastqFile1LastPathComponent = [ NSString stringWithFormat:@"%@_R1_%@", tAr [ 0 ], tAr[ 1 ] ];
        tFastqFile2LastPathComponent = [ filePath lastPathComponent ];
        if( [ [ tFastqFile1LastPathComponent pathExtension ] isEqualToString:@"fastq" ] ) {
            if( [ fileManager fileExistsAtPath:[ NSString stringWithFormat:@"%@/%@", tFastqFileDir,tFastqFile1LastPathComponent ] ] ) {
                tFileExistFlag = 1;
            } else if( [ fileManager fileExistsAtPath:[ NSString stringWithFormat:@"%@/%@.gz", tFastqFileDir, tFastqFile1LastPathComponent ] ] ) {
                tFastqFile1LastPathComponent = [ NSString stringWithFormat:@"%@.gz", tFastqFile1LastPathComponent ];
                tFileExistFlag = 1;
            }
        } else if( [ [ tFastqFile1LastPathComponent pathExtension ] isEqualToString:@"gz" ] ) {
            if( [ fileManager fileExistsAtPath:[ NSString stringWithFormat:@"%@/%@", tFastqFileDir,tFastqFile1LastPathComponent ] ] ) {
                tFileExistFlag = 1;
            } else if( [ fileManager fileExistsAtPath:[ NSString stringWithFormat:@"%@/%@", tFastqFileDir, [ tFastqFile1LastPathComponent stringByDeletingPathExtension ] ] ] ) {
                tFastqFile1LastPathComponent = [ NSString stringWithFormat:@"%@", [ tFastqFile1LastPathComponent stringByDeletingPathExtension ] ];
                tFileExistFlag = 1;
            }
        }
    }
    // Set up summaryForEachPatient.file1, summaryForEachPatient.file2, and summaryForEachPatient.selectedPatientRowNo.  WindowController's windowDidLoad routine update the window accordingly.
    mainRoutine.summaryForEachPatient.file1 = file1 = tFastqFile1LastPathComponent;
    mainRoutine.summaryForEachPatient.file2 = file2 = tFastqFile2LastPathComponent;
    mainRoutine.selectedPatientRowNo = -1;
    fastqFileDir = tFastqFileDir;
    
    if( tFileExistFlag == 0 ) {
        [ [ NSAlert alertWithMessageText:@"Files are not paired or incompatible." defaultButton:@"OK" alternateButton:nil otherButton:nil informativeTextWithFormat:@"" ] runModal ];
        return NO;
    }
    return YES;
}

-( void )displayError:( NSString * )message {
    NSTextView *tTV = windowController.errorLogTextView;
    [ [ [ tTV textStorage ] mutableString ] appendString:message ];
    [ windowController.errorLogWindow makeKeyAndOrderFront:self ];
}


@end
