//
//  SummaryForEachPatient.m
//  MINtS analyzer
//
//  Created by 萩原 弘一 on 2014/05/09.
//  Copyright (c) 2014年 萩原 弘一. All rights reserved.
//
/* Copyright 2016 Koichi Hagiwara
 This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#import "SummaryForEachPatient.h"

@implementation SummaryForEachPatient
@synthesize file1;
@synthesize file2;
@synthesize fastqFileDir;
@synthesize patientNo;
@synthesize totalNumberOfReads;
@synthesize readsFailedToBeMapped;
@synthesize readsMapped;
@synthesize mutDomains;
@synthesize germlineDNAResultMutAr;
@synthesize somaticDNAResultMutAr;
@synthesize germlineRNAResultMutAr;
@synthesize somaticRNAResultMutAr;

-( void )encodeWithCoder:( NSCoder * )aCoder {
    [ aCoder encodeObject:file1 forKey:@"file1" ];
    [ aCoder encodeObject:file2 forKey:@"file2" ];
    [ aCoder encodeObject:fastqFileDir forKey:@"fastqFileDir" ];
    [ aCoder encodeObject:patientNo forKey:@"patientNo" ];
    [ aCoder encodeInt64:totalNumberOfReads forKey:@"totalNumberOfReads" ];
    [ aCoder encodeInt64:readsFailedToBeMapped forKey:@"readsFailedToBeMapped" ];
    [ aCoder encodeInt64:readsMapped forKey:@"readsMapped" ];
    [ aCoder encodeObject:mutDomains forKey:@"mutDomains" ];
    [ aCoder encodeObject:germlineDNAResultMutAr forKey:@"germlineDNAResultMutAr" ];
    [ aCoder encodeObject:somaticDNAResultMutAr forKey:@"somaticDNAResultMutAr" ];
    [ aCoder encodeObject:germlineRNAResultMutAr forKey:@"germlineRNAResultMutAr" ];
    [ aCoder encodeObject:somaticRNAResultMutAr forKey:@"somaticRNAResultMutAr" ];
}

-( id )initWithCoder:( NSCoder * )aDecoder {
    self = [ super init ];
    file1 = [ aDecoder decodeObjectForKey:@"file1" ];
    file2 = [ aDecoder decodeObjectForKey:@"file2" ];
    fastqFileDir = [ aDecoder decodeObjectForKey:@"fastqFileDir" ];
    patientNo = [ aDecoder decodeObjectForKey:@"patientNo" ];
    totalNumberOfReads = [ aDecoder decodeInt64ForKey:@"totalNumberOfReads" ];
    readsFailedToBeMapped = [ aDecoder decodeInt64ForKey:@"readsFailedToBeMapped" ];
    readsMapped = [ aDecoder decodeInt64ForKey:@"readsMapped" ];
    mutDomains = [ aDecoder decodeObjectForKey:@"mutDomains" ];
    germlineDNAResultMutAr = [ aDecoder decodeObjectForKey:@"germlineDNAResultMutAr" ];
    somaticDNAResultMutAr = [ aDecoder decodeObjectForKey:@"somaticDNAResultMutAr" ];
    germlineRNAResultMutAr = [ aDecoder decodeObjectForKey:@"germlineRNAResultMutAr" ];
    somaticRNAResultMutAr = [ aDecoder decodeObjectForKey:@"somaticRNAResultMutAr" ];
    return self;
}

-( id )copyWithZone:( NSZone * )zone {
    SummaryForEachPatient *tempCopy = [ [ [ self class ] allocWithZone:zone ] init ];
    if( tempCopy ) {
        tempCopy.file1 = [ file1 copyWithZone:zone ];
        tempCopy.file2 = [ file2 copyWithZone:zone ];
        tempCopy.fastqFileDir = [ fastqFileDir copyWithZone:zone ];
        tempCopy.patientNo = [ patientNo copyWithZone:zone ];
        tempCopy.totalNumberOfReads = totalNumberOfReads;
        tempCopy.readsFailedToBeMapped = readsFailedToBeMapped;
        tempCopy.readsMapped = readsMapped;
        tempCopy.mutDomains = [ NSKeyedUnarchiver unarchiveObjectWithData:
                               [ NSKeyedArchiver archivedDataWithRootObject:mutDomains ] ];
        tempCopy.germlineDNAResultMutAr = [ NSKeyedUnarchiver unarchiveObjectWithData:
                               [ NSKeyedArchiver archivedDataWithRootObject:germlineDNAResultMutAr ] ];
        tempCopy.somaticDNAResultMutAr = [ NSKeyedUnarchiver unarchiveObjectWithData:
                               [ NSKeyedArchiver archivedDataWithRootObject:somaticDNAResultMutAr ] ];
        tempCopy.germlineRNAResultMutAr = [ NSKeyedUnarchiver unarchiveObjectWithData:
                                           [ NSKeyedArchiver archivedDataWithRootObject:germlineRNAResultMutAr ] ];
        tempCopy.somaticRNAResultMutAr = [ NSKeyedUnarchiver unarchiveObjectWithData:
                                          [ NSKeyedArchiver archivedDataWithRootObject:somaticRNAResultMutAr ] ];
    }
    return tempCopy;
}

-( id )initWithMutDomains:( NSMutableArray * )tMutDomains {
    self = [ super init ];
    if( self ) {
        file1 = @"";
        file2 = @"";
        fastqFileDir = @"";
        patientNo = @"";
        totalNumberOfReads = 0;
        readsFailedToBeMapped = 0;
        readsMapped = 0;
        mutDomains = [ NSKeyedUnarchiver unarchiveObjectWithData:
                      [ NSKeyedArchiver archivedDataWithRootObject:tMutDomains ] ];
        germlineDNAResultMutAr = [ [ NSMutableArray alloc ] initWithCapacity:1 ];
        somaticDNAResultMutAr = [ [ NSMutableArray alloc ] initWithCapacity:1 ];
        germlineRNAResultMutAr = [ [ NSMutableArray alloc ] initWithCapacity:1 ];
        somaticRNAResultMutAr = [ [ NSMutableArray alloc ] initWithCapacity:1 ];
    }
    return self;
}

@end
