//
//  WindowController.h
//  MINtS analyzer
//
//  Created by 萩原 弘一 on 2013/09/05.
//  Copyright (c) 2013年 萩原 弘一. All rights reserved.
//
/* Copyright 2016 Koichi Hagiwara
 This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#import <Cocoa/Cocoa.h>
@class MintsDocument;
@class SummaryForEachPatient;
@interface WindowController : NSWindowController {
    MintsDocument *mintsDocument;
    MainRoutine *mainRoutine;
    IBOutlet NSWindow *mainWindow;
    IBOutlet NSTextField *file1TextField;
    IBOutlet NSTextField *file2TextField;
    IBOutlet NSTextField *totalNumberOfReadsTextField;
    IBOutlet NSTextField *totalNumberOfIntormativeReadsTextField;
    IBOutlet NSTextField *readsMappedTextField;
    IBOutlet NSTextField *readsFailedToBeMappedTextField;
    IBOutlet NSTableView *patientsNoTableView;
    IBOutlet NSTableView *germlineDNAResultTableView;
    IBOutlet NSTableView *somaticDNAResultTableView;
    IBOutlet NSTableView *germlineRNAResultTableView;
    IBOutlet NSTableView *somaticRNAResultTableView;
    IBOutlet NSTextField *germlineDNAResultTextField;
    IBOutlet NSTextField *somaticDNAResultTextField;
    IBOutlet NSTextField *germlineRNAResultTextField;
    IBOutlet NSTextField *somaticRNAResultTextField;
    IBOutlet NSButton *analyzeButton;
    IBOutlet NSButton *analyzeAllButton;
    IBOutlet NSWindow *errorLogWindow;
    IBOutlet NSTextView *errorLogTextView;
    BOOL	 indicator;
    NSString *totalNumberOfReads;
    NSString *totalNumberOfOverlappedReads;
    NSString *readsMapped;
    NSString *readsFailedToBeMapped;
    //
    NSPopover *popover;
    IBOutlet  NSViewController *popoverViewControllerHUD;
    SummaryForEachPatient *summaryForEachPatientUsedForPopover;
    MutDomain *mutDomainUsedForPopover;
    IBOutlet NSTableView *popoverTableView;
    IBOutlet NSTextField *popoverCommentTextField;
}

-( IBAction )analyzeAll:( id )sender;
-( IBAction )analyze:( id )sender;
-( BOOL )validateMenuItem:( NSMenuItem * )anItem;
-( IBAction )showErrorLogWindow:( id )sender;
-( void )cancelOperation:( id )sender;
-( IBAction )doubleClickAction:( id )sender;
-( void )updateWindowFromSummaryForEachPatient:( SummaryForEachPatient * )tSummaryForEachPatient;

@property MintsDocument    *mintsDocument;
@property MainRoutine *mainRoutine;
@property NSTextField *file1TextField;
@property NSTextField *file2TextField;
@property NSWindow *mainWindow;
@property NSTextField *totalNumberOfReadsTextField;
@property NSTextField *totalNumberOfIntormativeReadsTextField;
@property NSTextField *readsMappedTextField;
@property NSTextField *readsFailedToBeMappedTextField;
@property NSTableView *germlineDNAResultTableView;
@property NSTableView *somaticDNAResultTableView;
@property NSTableView *germlineRNAResultTableView;
@property NSTableView *somaticRNAResultTableView;
@property NSTextField *germlineDNAResultTextField;
@property NSTextField *somaticDNAResultTextField;
@property NSTextField *germlineRNAResultTextField;
@property NSTextField *somaticRNAResultTextField;
@property NSButton *analyzeButton;
@property NSButton *analyzeAllButton;
@property BOOL    indicator;
@property NSString *totalNumberOfReads;
@property NSString *totalNumberOfOverlappedReads;
@property NSString *readsMapped;
@property NSString *readsFailedToBeMapped;
@property NSTextView *errorLogTextView;
@property NSWindow *errorLogWindow;
@property NSTableView *patientsNoTableView;
@property NSViewController *popoverViewControllerHUD;
@property NSPopover *popover;
@property SummaryForEachPatient *summaryForEachPatientUsedForPopover;
@property MutDomain *mutDomainUsedForPopover;
@property NSTableView *popoverTableView;
@property NSTextField *popoverCommentTextField;

@end
